// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VrScope.pas' rev: 5.00

#ifndef VrScopeHPP
#define VrScopeHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <VrThreads.hpp>	// Pascal unit
#include <VrSysUtils.hpp>	// Pascal unit
#include <VrClasses.hpp>	// Pascal unit
#include <VrControls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vrscope
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TGraphStyle { gsLine, gsBar };
#pragma option pop

#pragma option push -b-
enum TScrolldirection { sdRightToLeft, sdLeftToRight };
#pragma option pop

class DELPHICLASS TVrChannel;
class PASCALIMPLEMENTATION TVrChannel : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	Graphics::TColor FColor;
	int FWidth;
	TGraphStyle FStyle;
	AnsiString FSerie;
	bool FVisible;
	void __fastcall SetColor(Graphics::TColor Value);
	void __fastcall SetWidth(int Value);
	void __fastcall SetStyle(TGraphStyle Value);
	void __fastcall SetVisible(const bool Value);
	
protected:
	void __fastcall AddValue(int Value, int BufSize);
	__property AnsiString Serie = {read=FSerie, write=FSerie};
	
public:
	__fastcall virtual TVrChannel(Classes::TCollection* Collection);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=65535};
	__property int Width = {read=FWidth, write=SetWidth, default=1};
	__property TGraphStyle Style = {read=FStyle, write=SetStyle, default=0};
	__property bool Visible = {read=FVisible, write=SetVisible, default=1};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TVrChannel(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVrChannels;
class DELPHICLASS TVrScope;
typedef int TVrScopeInt;

typedef Shortint TVrBaseOffsetInt;

typedef void __fastcall (__closure *TVrNeedDataEvent)(System::TObject* Sender, int Channel, int &Value
	);

class PASCALIMPLEMENTATION TVrScope : public Vrcontrols::TVrGraphicImageControl 
{
	typedef Vrcontrols::TVrGraphicImageControl inherited;
	
private:
	TVrScopeInt FMinValue;
	TVrScopeInt FMaxValue;
	bool FActive;
	bool FAnimateGrid;
	Graphics::TBitmap* FGrid;
	Vrcontrols::TVrMaxInt FGridSize;
	int FGridOffset;
	TVrBaseOffsetInt FBaseOffset;
	Graphics::TColor FBaseColor;
	Vrthreads::TVrTimer* FTimer;
	TVrChannels* FChannels;
	int FGridLineWidth;
	Graphics::TColor FGridColor;
	Vrcontrols::TVrMaxInt FFrequency;
	int FBufferSize;
	TVrNeedDataEvent FOnNeedData;
	int BaseInt;
	bool Painting;
	TScrolldirection FDirection;
	bool FAutoUpdate;
	int __fastcall GetInterval(void);
	bool __fastcall GetThreaded(void);
	void __fastcall SetInterval(int Value);
	void __fastcall SetActive(bool Value);
	void __fastcall SetMaxValue(TVrScopeInt Value);
	void __fastcall SetMinValue(TVrScopeInt Value);
	void __fastcall SetChannels(TVrChannels* Value);
	void __fastcall SetGridSize(Vrcontrols::TVrMaxInt Value);
	void __fastcall SetGridLineWidth(int Value);
	void __fastcall SetGridColor(Graphics::TColor Value);
	void __fastcall SetBaseOffset(TVrBaseOffsetInt Value);
	void __fastcall SetBaseColor(Graphics::TColor Value);
	void __fastcall SetFrequency(Vrcontrols::TVrMaxInt Value);
	void __fastcall SetThreaded(bool Value);
	void __fastcall TimerEvent(System::TObject* Sender);
	void __fastcall setDirection(const TScrolldirection Value);
	void __fastcall SetAutoUpdate(const bool Value);
	
protected:
	virtual void __fastcall Paint(void);
	void __fastcall CreateGrid(void);
	void __fastcall CreateGraph(void);
	int __fastcall GetPlotValue(AnsiString &S);
	
public:
	__fastcall virtual TVrScope(Classes::TComponent* AOwner);
	__fastcall virtual ~TVrScope(void);
	void __fastcall Clear(void);
	void __fastcall SetData(int Channel, int Value);
	void __fastcall AddData(void);
	
__published:
	__property bool AutoUpdate = {read=FAutoUpdate, write=SetAutoUpdate, default=1};
	__property int Interval = {read=GetInterval, write=SetInterval, nodefault};
	__property bool AnimateGrid = {read=FAnimateGrid, write=FAnimateGrid, default=1};
	__property TVrScopeInt MaxValue = {read=FMaxValue, write=SetMaxValue, default=100};
	__property TVrScopeInt MinValue = {read=FMinValue, write=SetMinValue, default=0};
	__property TVrChannels* Channels = {read=FChannels, write=SetChannels};
	__property TScrolldirection Direction = {read=FDirection, write=setDirection, default=0};
	__property Vrcontrols::TVrMaxInt GridSize = {read=FGridSize, write=SetGridSize, default=16};
	__property int GridLineWidth = {read=FGridLineWidth, write=SetGridLineWidth, default=1};
	__property Graphics::TColor GridColor = {read=FGridColor, write=SetGridColor, default=32768};
	__property TVrBaseOffsetInt BaseOffset = {read=FBaseOffset, write=SetBaseOffset, default=50};
	__property Graphics::TColor BaseColor = {read=FBaseColor, write=SetBaseColor, default=65280};
	__property Vrcontrols::TVrMaxInt Frequency = {read=FFrequency, write=SetFrequency, default=2};
	__property int BufferSize = {read=FBufferSize, write=FBufferSize, default=999};
	__property bool Threaded = {read=GetThreaded, write=SetThreaded, nodefault};
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property TVrNeedDataEvent OnNeedData = {read=FOnNeedData, write=FOnNeedData};
	__property Align ;
	__property Anchors ;
	__property Constraints ;
	__property Color ;
	__property DragCursor ;
	__property DragKind ;
	__property DragMode ;
	__property Hint ;
	__property ParentColor ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible ;
	__property OnClick ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDock ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDock ;
	__property OnStartDrag ;
};


class PASCALIMPLEMENTATION TVrChannels : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	TVrScope* FScope;
	HIDESBASE TVrChannel* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, TVrChannel* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	__fastcall TVrChannels(TVrScope* Scope2);
	HIDESBASE TVrChannel* __fastcall Add(void);
	__property TVrChannel* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TVrChannels(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Vrscope */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Vrscope;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VrScope
